/*
 * $RCSfile: ApplicationMenu.java,v $
 *
 * Copyright (c) 1999-2002. Christian Heller. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package org.resmedicinae.application.common.main;

/*
 * Caution: Don't add java.awt.* here!
 * The awt contains equally named classes that would conflict with this class.
 */
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import javax.swing.*;
import javax.swing.tree.*;
import org.resmedicinae.resmedlib.component.control.*;
import org.resmedicinae.resmedlib.component.view.swing.*;

/**
 * This class represents an application menu.
 *
 * @version $Revision: 1.1 $ $Date: 2002/06/06 18:19:48 $
 * @author $Author: chrissy $
 * @author Christian Heller
 */
public class ApplicationMenu extends ResMenu {

    /** The application tree node. */
    private ApplicationTreeNode applicationTreeNode;

    /**
     * Constructs this object.
     */
    public ApplicationMenu() {

        super();

/*??
        if (n != null) {

            setApplicationTreeNode(n);
            setText(n.toString());
            setActionCommand("createApplication");
            // Read characters from application name and add key event such that no redundant key combinations are used.
            // Just adding numbers at the end of the name?
//??            setMnemonic(KeyEvent.VK_M);

            Enumeration enum = n.children();
            ApplicationTreeNode child = null;

            while (enum.hasMoreElements()) {

                child = (ApplicationTreeNode) enum.nextElement();

                ApplicationMenu m = new ApplicationMenu(child, controlId);

                add(m);
            }
        }
*/
    }

    //
    // Application tree node.
    //

    /**
     * Returns the application tree node.
     *
     * @return the application tree node
     */
    public ApplicationTreeNode getApplicationTreeNode() {

        return this.applicationTreeNode;
    }

    /**
     * Sets the application tree node.
     *
     * @param applicationTreeNode the application tree node
     */
    public void setApplicationTreeNode(ApplicationTreeNode applicationTreeNode) {

        this.applicationTreeNode = applicationTreeNode;
    }

    //
    // Create control.
    //
    
    /**
     * Creates a control.
     *
     * @return the control issued when the button is pressed
     * @exception NullPointerException if the control is null
     */
/*??
    protected org.scopemvc.core.Control createControl() throws NullPointerException {
        
        Control c = new Control();

        if (c != null) {

            c.setControlId(getControlId());
            c.setParameter(getApplicationTreeNode());
            
        } else {
            
            throw new NullPointerException("Could not create control. The control is null.");
        }

        return c;
    }
*/
}

