/*
 * $RCSfile: BasicControllerView.java,v $
 *
 * Copyright (c) 1999-2002. Christian Heller. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package org.resmedicinae.application.controller.basic;

import java.lang.*;
import org.resmedicinae.resmedlib.component.control.*;
import org.resmedicinae.resmedlib.component.view.swing.*;

/**
 * This class represents a basic controller view.
 *
 * Design patterns:
 * - View in Model View Controller
 *
 * @version $Revision: 1.2 $ $Date: 2002/06/12 18:49:35 $ $Author: chrissy $
 * @author Christian Heller <christian.heller@tuxtax.de>
 */
public class BasicControllerView extends SwingView {

    //
    // Close control.
    //

    /**
     * Creates a control issued when the window containing this view is closed.
     *
     * @return the control issued when the window containing this view is closed
     */
    public Control createCloseControl() {

        return null; //?? new Control(BasicController.DESTROY_CONTROLLER_CONTROL_ID);
    }
}


