/*

 * $RCSfile: RecordLocalFacade.java,v $

 *

 * Copyright (c) 1999-2002. Christian Heller. All rights reserved.

 *

 * This software is published under the GPL GNU General Public License.

 * This program is free software; you can redistribute it and/or

 * modify it under the terms of the GNU General Public License

 * as published by the Free Software Foundation; either version 2

 * of the License, or (at your option) any later version.

 *

 * This program is distributed in the hope that it will be useful,

 * but WITHOUT ANY WARRANTY; without even the implied warranty of

 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the

 * GNU General Public License for more details.

 *

 * You should have received a copy of the GNU General Public License

 * along with this program; if not, write to the Free Software

 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 *

 * http://www.resmedicinae.org

 * - Information in Medicine -

 */

package org.resmedicinae.application.healthcare.record;

import org.resmedicinae.domain.healthcare.*;
import org.resmedicinae.resmedlib.component.model.jdbc.*;

/**
 * This class represents the record local facade.
 * @version $Revision: 1.13 $ $Date: 2002/10/17 15:44:00 $ $Author: zone3 $
 * @author Christian Heller <christian.heller@tuxtax.de>
 */
public class RecordLocalFacade extends JdbcFacade implements RecordFacade {
    /** The person finder. */
    private PersonFinder personFinder;

    /**
     * Returns the person finder.
     * @return the person finder
     */
    public PersonFinder getPersonFinder() {
        return this.personFinder;
    }

    /**
     * Sets the person finder.
     * @param personFinder the person finder
     */
    public void setPersonFinder(PersonFinder personFinder) {
        this.personFinder = personFinder;
    }

    /**
     * Returns the person with the given name.
     * @param name the person name
     * @exception NullPointerException if the person finder is null
     */

    /* public Person getPerson(String name) throws NullPointerException {
         Person p = null;
         PersonFinder f = getPersonFinder();
         if (f != null) {*/

/*??

            PreparedStatement s = createPreparedStatement();

            p = f.find(name);

*/

    /*} else {
        throw new NullPointerException("Could not load person. The person finder is null.");
    }
    return p;
}     */
}
