/*
 * $RCSfile: RecordMessages.java,v $
 *
 * Copyright (c) 1999-2002. Jens Bohl. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package org.resmedicinae.application.healthcare.record;

/** This class provides all nessecary messages for the output of the system.
 * @author Jens Bohl <info@jens-bohl-professional.de>
 *  */
public class RecordMessages {
    public static final String READY_MESSAGE = "READY.";
    public static final String EXIT_MESSAGE = "GOOD BYE.";
    public static final String CREATE_NEW_OVERLAY_MESSAGE = "CREATE NEW OVERLAY.";
    public static final String REMOVE_OVERLAY_MESSAGE = "REMOVE OVERLAY.";
    public static final String EDIT_OVERLAY_MESSAGE = "EDIT OVERLAY.";
    public static final String REGION_TRANSPARENT_MESSAGE = "OVERLAY REGIONS ARE NOW TRANSPARENT.";
    public static final String REGION_TRANSPARENT_WITH_ALPHA_VALUE_MESSAGE = "OVERLAY REGIONS ARE NOW TRANSPARENT WITH ALPHA VALUE.";
    public static final String REGION_NOT_TRANSPARENT_MESSAGE = "OVERLAY REGIONS ARE NOW NOT TRANSPARENT.";
    public static final String MAKE_NEW_PATIENT_MESSAGE = "CREATE NEW HEALTHRECORD.";
    public static final String MAKE_NEW_PROBLEM_MESSAGE = "CREATE NEW PROBLEM.";
    public static final String LOAD_PATIENT_MESSAGE = "LOAD HEALTHRECORD.";
    public static final String MARKER_SUCESSFULLY_SAVED_MESSAGE = "MARKER SUCCESSFULLY SAVED.";
    public static final String NEW_EPISODE_TEMPLATE_CREATED_MESSAGE = "NEW EPISODE TEMPLATE CREATED.";
    public static final String BACK_TO_PREVIOUS_OVERLAY_SUCESSFULL_MESSAGE =
            "SUCCESSFULLY CHANGED TO PREVIOUS OVERLAY.";
    public static final String BACK_TO_PREVIOUS_OVERLAY_NOT_SUCESSFULL_MESSAGE =
            "ERROR WHILE CHANGING TO PREVIOUS OVERLAY.";
    public static final String OVERLAY_SUCESSFULLY_REMOVED_MESSAGE = "OVERLAY SUCCESSFULLY REMOVED.";
    public static final String OVERLAY_NOT_SUCESSFULLY_REMOVED_MESSAGE = "ERROR WHILE REMOVING OVERLAY.";
    public static final String CHOOSE_PICTURE_MESSAGE = "CHOOSE IMAGE FOR OVERLAY.";
    public static final String OVERLAY_SUCESSFULLY_CREATED_MESSAGE = "OVERLAY SUCCESSFULLY CREATED.";
    public static final String FIELD_LEFT_EMPTY_MESSAGE = "FIELDS NOT CORRECT FILLED.";
    public static final String NEW_REGION_DRAWN_MESSAGE = "NEW REGION PAINTED.";
    public static final String REGION_REMOVED_MESSAGE = "REGION REMOVED.";
    public static final String REMOVED_LAST_REGION_POINT_MESSAGE = "REMOVED LAST POINT:";
    public static final String CHANGED_FILE_MESSAGE = "CHANGED TO OVERLAY: ";
    public static final String COULD_NOT_CHANGED_FILE_MESSAGE = "COULD NOT CHANGE TO OVERLAY.";
    public static final String NEW_REGION_SUCESSFULLY_CREATED_MESSAGE = "NEW REGION SUCCESSFULLY CREATED.";
    public static final String NEW_REGION_NOT_SUCESSFULLY_CREATED_MESSAGE = "ERROR WHILE CREATING NEW REGION.";
    public static final String REGION_SUCESSFULLY_REMOVED_MESSAGE = "RGION SUCCESSFULLY REMOVED.";
    public static final String REGION_NOT_SUCESSFULLY_REMOVED_MESSAGE = "ERRORR WHILE REMOVING REGION.";
    public static final String NO_PATIENT_SELECTED_MESSAGE = "NO HEALTHRECORD SELECTED.";
    public static final String PATIENT_SUCESSFULLY_LOADED_MESSAGE = "HEALTHRECORD SUCCESSFULLY LOADED.";
    public static final String PATIENT_NOT_SUCESSFULLY_LOADED_MESSAGE = "ERROR WHILE LOADING HEALTHRECORD.";
    public static final String PATIENT_SUCESSFULLY_CREATED_MESSAGE = "HEALTHRECORD SUCCESSFULLY CREATED.";
    public static final String MAKE_PATIENT_DIALOG_FIELD_LEFT_EMPTY_MESSAGE = "FIELDS LEFT EMPTY.";
    public static final String ALL_FIELDS_CLEARED_MESSAGE = "FIELDS CLEARED.";
    public static final String NEW_PROBLEM_SUCESSFULLY_CREATED_MESSAGE = "PROBLEM SUCCESSFULLY CREATED.";
    public static final String EPISODE_SUCESSFULLY_CREATED_MESSAGE = "EPISODE SUCCESSFULLY CREATED.";
    public static final String MAKE_NEW_REPORT_ON_OVERLAY_MESSAGE = "CREATE NEW REPORT.";
    public static final String SWITCHED_TO_REGION_NOT_SUCESSFULL_MESSAGE =
            "COULD NOT SWITCH TO NEIGHBOUR REGION. THE REGION IS NOT AVAILABLE:";
    public static final String SWITCHED_TO_REGION_SUCESSFULL_MESSAGE = "SUCCESSFULLY SWITCHED TO REGION: ";
    public static final String NO_SUGGESTIONS_MESSAGE = "NO SUGGESTIONS.";
    public static final String MARKER_DRAWN_MESSAGE = "MARKER DRAWN.";
    public static final String COULD_NOT_DRAW_MARKER_MESSAGE = "COULD NOT DRAW MARKER.";
    public static final String NO_EPISODE_LOADED_MESSAGE = "NO EPISODE LOADED.";
    public static final String REGION_POINT_DRAWN_MESSAGE = "POINT OF REGION DRAWN.";
    public static final String EDIT_REGION_MESSAGE = "EDIT REGION.";
    public static final String SHOW_CURRENT_REGION_MESSAGE = "CURRENT REGION: ";
    public static final String POSSIBLE_NAMES_MESSAGE = "SUGGESTED HEALTHRECORDS.";
    public static final String NO_PICTURE_FOR_EPISODE_FOUND_MESSAGE = "OVERLAY COULD NOT BE LOADED: ";
    public static final String NO_PATIENT_LOADED_MESSAGE = "NO PATIENT LOADED.";
    public static final String COULD_NOT_REMOVE_PROBLEM_MESSAGE = "PROBLEM COULD NOT BE REMOVED.";
    public static final String PROBLEM_SUCESSFULLY_REMOVED_MESSAGE = "PROBLEM SUCCESSFULLY REMOVED.";
    public static final String NO_PROBLEM_LOADED_MESSAGE = "NO PROBLEM LOADED.";
    public static final String NO_OBJECT_LOADED_MESSAGE = "NO OBJECTIVE LOADED.";
    public static final String EPISODE_SUCESSFULLY_REMOVED_MESSAGE = "EPISODE SUCCESSFULLY REMOVED.";
    public static final String EDIT_ALTERNATIVE_OVERLAYS_MESSAGE = "EDIT ALTERNATIVE OVERLAYS.";
    public static final String ALTERNATIVE_OVERLAY_ALREADY_IN_LIST_MESSAGE = "ALTERNATIVE OVERLAY ALREADY IN LIST.";
    public static final String NO_ALTERNATIVE_OVERLAY_SELECTED_MESSAGE = "NO ALTERNATIVE OVERLAY CHOOSED.";
    public static final String KEYBOARD_CONTROL_SELECTED_MESSAGE = "KEYBOARD AND MOUSE CONTROL.";
    public static final String MOUSE_CONTROL_SELECTED_MESSAGE = "ONLY MOUS CONTROL.";
    public static final String PARTIAL_CONTACT_SUCESSFULLY_REMOVED_MESSAGE = "PARTIAL CONTACT SUCCESSFULLY REMOVED.";
    public static final String NO_PARTIAL_CONTACT_LOADED_MESSAGE = "NO PARTIAL CONTACT LOADED.";
    public static final String PARTIAL_CONTACT_REMOVED_MESSAGE = "PARTIAL CONTACT SUCCESSFULLY REMOVED.";
    public static final String DISEASE_SUCESSFULLY_REMOVED_MESSAGE = "DISEASE SUCCESSFULLY REMOVED:";
}
