/*
 * $RCSfile: IModel.java,v $
 *
 * Copyright (c) 1999-2002. The Res Medicinae Developers. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

/**
 * The class is the interface for all model
 *
 * @version         $Revision: 1.3 $
 *                  $Date: 2002/12/12 13:37:39 $
 *                  $Author: rholzmueller $
 * @author Rolf Holzmller <rolf.holzmueller@gmx.de>
 */

package org.resmedicinae.application.healthcare.resdata.model;


import java.util.HashMap;


public interface IModel {

    /**
     *
     * initialiation the model
     *
     * @param action for wich action to be initialiation
     *
     */
    public void init( String action );


    /**
     *
     * run the model with parameter
     *
     * @param param the parameter for the running of the model
     *
     */
    public void run ( HashMap param );

    /**
     *
     * return the modelstaus of the model. This is
     * for example the status for the error or
     * for succerssfull running
     *
     * @return int modelstatus of the model
     */
    public int getModelstatus();

    /**
     *
     * return the modeldata
     *
     * @return HashMap the datat of the model
     *
     */
    public HashMap getModelData();
}
