/*
 * $RCSfile: TopologyScrollPane.java,v $
 *
 * Copyright (c) 1999-2003. Jens Bohl. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package resmedicinae.record.topology;

import resmedicinae.record.*;

import javax.swing.*;
import java.awt.*;

/** This class represents a special ScollPane. Border and policies are set. A titledBorder surrounds the panel.
 * @author Jens Bohl <info@jens-bohl-professional.de>
 *  */
public class TopologyScrollPane extends JScrollPane {
    /**Constructor
     * @param component the component within this scrollPane
     * @param title the title of the border of this scrollPane
     */
    public TopologyScrollPane(JComponent component, String title) {
        super(component);
        setPreferredSize(component.getPreferredSize());
        setBorder(BorderFactory.createTitledBorder(title));
        initialize();
    }

    /**Initialization of components*/
    public void initialize() {
        setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        setBackground(RecordModel.BackgroundColor);
        setFont(new Font("title", Font.BOLD, 12));
    }
}
