/*
 * $RCSfile: JavaMessageServiceAssembler.java,v $
 *
 * Copyright (c) 1999-2002. Christian Heller. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package reform.resmedicinae.reform.region.assembler;

import reform.resmedicinae.reform.region.model.*;
import org.resmedicinae.resmedlib.region.assembler.*;
import org.resmedicinae.resmedlib.term.String;

/**
 * This class represents a data transfer model assembler.
 * It can be used to assemble/disassemble a data transfer model from/to a domain model.
 * @version $Revision: 1.1 $ $Date: 2003/03/11 12:53:50 $ $Author: zone3 $
 * @author Torsten Kunze <zone3@gmx.de>
 * @author Christian Heller <christian.heller@tuxtax.de>
 */
public class JavaMessageServiceAssembler extends DataTransferAssembler {
    public static final String ASSEMBLER_KEY = "JAVA_MESSAGE_SERVICE_MODEL_ASSEMBLER_KEY";
    private HealthRecordViewModel model;

    public void initialize() throws Exception {
        try {
            super.initialize();
        } catch (Exception e) {
            throw new Exception(e);
        }
    }

    public HealthRecordViewModel getModel() {
        return model;
    }

    public void setModel(HealthRecordViewModel model) {
        this.model = model;
    }
}
