/*
 * $RCSfile: Decoder.java,v $
 *
 * Copyright (c) 1999-2002. The Res Medicinae developers. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package org.resmedicinae.resmedlib.region.controller;

import org.resmedicinae.resmedlib.region.*;
import org.resmedicinae.resmedlib.region.model.*;
//?? Temporary!
import org.resmedicinae.resmedlib.block.view.GraphicalView;

/**
 * This class represents a decoder.
 *
 * It can be used to decode any kind of data model into a domain model.
 *
 * A decoder corresponds to the sensoric nerve system of a human being.
 * For example, the brain region for seeing decodes optical data into the
 * proper abstract domain model of our brain.
 *
 * Synonyms: Assembler, Mapper, Sensor 
 *
 * @version $Revision: 1.1 $ $Date: 2002/12/19 12:35:32 $ $Author: chrissy $
 * @author Christian Heller <christian.heller@tuxtax.de>
 */
public class Decoder extends ControllerRegion {

    //
    // Decoding.
    //
    
    /**
     * Decodes the data model.
     *
     * @param d the encoded data model
     * @return the decoded domain model
     */
    public DomainModel decode(GraphicalView d) {
        
        return null;
    }
}

