/*
 * $RCSfile: PortalSplitPane.java,v $
 *
 * Copyright (c) 1999-2002. The Res Medicinae developers. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package org.resmedicinae.resmedlib.region.view.graphical;

import org.resmedicinae.resmedlib.*;

/**
 * This class represents a portal split pane.
 *
 * @version $Revision: 1.1 $ $Date: 2002/12/11 17:48:19 $ $Author: chrissy $
 * @author Christian Heller <christian.heller@tuxtax.de>
 */
public class PortalSplitPane extends SplitPane {

    //
    // Left component.
    //

    /**
     * Creates a system tree.
     *
     * @return the system tree
     * @exception NullPointerException if the system tree is null
     */
    public Component createLeftComponent() throws Exception, NullPointerException {

        Tree t = new Tree();

        if (t != null) {

            t.globalize(get(PortalSplitPane.GLOBALS));
            t.initialize();
            t.link();

        } else {

            throw new NullPointerException("Could not create system tree. The system tree is null.");
        }

        return t;
    }
}

