/*
 * $RCSfile: Applet.java,v $
 *
 * Copyright (c) 1999-2002. The Res Medicinae developers. All rights reserved.
 *
 * This software is published under the GPL GNU General Public License.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * http://www.resmedicinae.org
 * - Information in Medicine -
 */

package org.resmedicinae.resmedlib.region.view.graphical.frame;

import org.resmedicinae.resmedlib.block.view.*;
import org.resmedicinae.resmedlib.region.view.graphical.*;

/**
 * This class represents an applet.
 *
 * @version $Revision: 1.1 $ $Date: 2002/12/11 17:48:19 $ $Author: chrissy $
 * @author Christian Heller <christian.heller@tuxtax.de>
 */
public class Applet extends Frame {

    //
    // Attributes.
    //

    /** The encapsulated swing applet. */
    private javax.swing.JApplet applet;

    //
    // Encapsulated swing applet.
    //
    
    /**
     * Creates an encapsulated swing applet.
     *
     * @return the encapsulated swing applet
     */
    public javax.swing.JApplet createApplet() {
        
        return new javax.swing.JApplet();
    }
    
    /**
     * Destroys the encapsulated swing applet.
     *
     * @param applet the encapsulated swing applet
     */
    public void destroyApplet(javax.swing.JApplet applet) {
    }
    
    /**
     * Sets the encapsulated swing applet.
     *
     * @param applet the encapsulated swing applet
     */
    public void setApplet(javax.swing.JApplet applet) {
     
        this.applet = applet;
    }
    
    /**
     * Returns the encapsulated swing applet.
     *
     * @return the encapsulated swing applet
     */
    public javax.swing.JApplet getApplet() {
     
        return this.applet;
    }

    //
    // Root pane.
    //

    /**
     * Creates a root pane.
     *
     * @return the root pane
     */
    public RootPane createRootPane() {

        return new RootPane();
    }

    /**
     * Destroys the root pane.
     *
     * @param rootPane the root pane
     */
    public void destroyRootPane(RootPane rootPane) {
    }
    
    //
    // Initialization.
    //
    
    /**
     * Initializes this applet.
     */
    public void initialize() throws Exception {
        
        setApplet(createApplet());
    }
    
    /**
     * Finalizes this applet.
     */
    public void finalizz() throws Exception {
        
        destroyApplet(getApplet());
        setApplet(null);
    }
}

